<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>纯 JS 实现放大缩小拖拽</title>
    <style>
    </style>
</head>
<body>
    <div class="box">
        <div class="move">
            <img
                onclick="moveBoxClick()"
                class="small-img"
                draggable="false"
                src="https://zcy-cdn.oss-cn-shanghai.aliyuncs.com/f2e-assets/103bbf76-6248-421c-a3d6-28a525c459db.png"
                alt=""
            />
            <img
                onclick="moveBoxClick()"
                class="magnify-img"
                draggable="false"
                src="https://zcy-cdn.oss-cn-shanghai.aliyuncs.com/f2e-assets/90e26f49-9824-4443-b4aa-8aa64a3c8690.png"
                alt=""
            />
            <div class="content"></div>
            </div>
        </div>
    <script>
        // window.onload=function(){
            const moveBox = document.querySelector(".move");
            const smallImg = document.querySelector(".move .small-img");
            const magnifyImg = document.querySelector(".move .magnify-img");
            var initX = 0; // 记录小采宝的x坐标
            var initY = 0; // 记录小采宝的y坐标
            let isMove = false; // 是否是拖动
            let isBig = false; // 是否是变大的盒子

            smallImg.onmousedown = magnifyImg.onmousedown = function(evt) {
                // 拖动div盒子
            const clientX = evt.clientX;
            const clientY = evt.clientY;
            const pageX = moveBox.offsetLeft;
            const pageY = moveBox.offsetTop;
            const x = clientX - pageX;
            const y = clientY - pageY;

            isMove = false;

            document.onmousemove = function(e) {
                const boxWidth = moveBox.offsetWidth;
                const boxHeight = moveBox.offsetHeight;
                let _x = e.clientX - x;
                let _y = e.clientY - y;
                if (_x < 0) {
                _x = 0;
                }
                if (_x > window.screen.width - boxWidth) {
                _x = window.screen.width - boxWidth;
                }
                if (_y < 0) {
                _y = 0;
                }
                if (_y > document.documentElement.clientHeight - boxHeight) {
                _y = document.documentElement.clientHeight - boxHeight;
                }

                if (isBig) {
                initX = _x;
                initY = _y;
                }

                moveBox.style.left = _x + "px";
                moveBox.style.top = _y + "px";

                isMove = true;
            };
            };


            document.onmouseup = function() {
            if (isMove) {
                initX = moveBox.offsetLeft;
                initY = moveBox.offsetTop;
            }
            document.onmousemove = null;
            };

            function moveBoxClick(e) {
            const target = document.querySelector(".move");
            const smallImg = document.querySelector(".small-img");
            const magnifyImg = document.querySelector(".magnify-img");
            // 点击move盒子
            if (!isMove) {
                if (isBig) {
                smallImg.style.display = "block";
                magnifyImg.style.display = "none";
                target.style.width = "32px";
                target.style.left = initX + 'px';
                target.style.top = initY + 'px';
                } else {
                smallImg.style.display = "none";
                magnifyImg.style.display = "block";
                target.style.width = "130px";
                }
                isBig = !isBig;

                setTimeout(() => {
                autoPotion();
                }, 100)
            }
            }

            // 点击时，判断采宝是否超出显示屏
            function autoPotion () {
            let x = moveBox.offsetLeft;
            let y = moveBox.offsetTop;

            if (x < 0) {
                x = 0;
            } else if (x > document.documentElement.clientWidth - moveBox.offsetWidth) {
                x = document.documentElement.clientWidth - moveBox.offsetWidth;
            }

            if (y < 0) {
                y = 0;
            } else if (y > document.documentElement.clientHeight - moveBox.offsetHeight) {
                y = document.documentElement.clientHeight - moveBox.offsetHeight;
            }

            moveBox.style.left = x + "px";
            moveBox.style.top = y + "px";
            }
        // }
    </script>
</body>
</html>